export declare enum Runtime {
    NODE10 = "nodejs10",
    NODE12 = "nodejs12",
    PYTHON36 = "python3.6",
    PYTHON37 = "python3.7",
    PYTHON38 = "python3.8"
}
export declare const supportedRuntimes: Runtime[];
export declare const supportedRuntimeSet: Set<Runtime>;
export declare enum RuntimeLanguages {
    NODE = "nodejs",
    PYTHON = "python"
}
export declare const supportedLanguages: RuntimeLanguages[];
export declare function isNodeRuntime(runtime: Runtime): boolean;
export declare function isPythonRuntime(runtime: Runtime): boolean;
export declare function getRuntimeVersion(runtime: Runtime): string;
export declare function getRuntimeLanguage(runtime: Runtime): string;
export declare enum FunctionAppOS {
    WINDOWS = "windows",
    LINUX = "linux"
}
export declare const dockerImages: {
    nodejs10: string;
    nodejs12: string;
    "python3.6": string;
    "python3.7": string;
    "python3.8": string;
};
