import Serverless from "serverless";
/**
 * Wrapper for azure-functions-core-tools commands. Was originally used heavily
 * to pack and publish function apps as a workaround for remote build, but since
 * that is working now, we don't need those functionalities. Keeping `start`
 * functionality as it is still used and is a good abstraction away from the
 * offline plugin.
 */
export declare class CoreToolsService {
    /**
     * Wrapper method for `func host start`
     * @param serverless Serverless instance
     * @param onFinish Function to run on finish
     * @param additionalArgs Additional arguments to core tools start
     */
    static start(serverless: Serverless, onFinish: () => void, additionalArgs?: string[]): Promise<void>;
}
